rem @echo off
if "%1"=="" goto usage

set ASM83DIR=%cd%\
cd %2
call %ASM83DIR%_getall.bat

echo ----- Assembling %1 for the TI-83 Plus...

echo #define TI83P >temp.z80
echo #define ION >>temp.z80
echo #define CRUNCHY >>temp.z80
if exist %1.z80 echo #include "%1.z80" >>temp.z80
if exist %1.asm echo #include "%1.asm" >>temp.z80
echo  .export SAVE_START  >> temp.z80
echo  .export SAVE_LENGTH >> temp.z80
echo PROG_SIZE = $-progstart >> temp.z80
echo  .export PROG_SIZE >> temp.z80

%ASM83DIR%tasm -80 -i -b -l temp.z80 %1.bin
if errorlevel 1 goto ERRORS
%ASM83DIR%pucrunch %1.bin %1.pu

echo #include "temp.exp" >temp.z80
echo  .db "cRu" >> temp.z80
echo #IF SAVE_LENGTH==0 >>temp.z80
echo  .dw PROG_SIZE,0 >> temp.z80
echo #else>>temp.z80
echo  .dw PROG_SIZE,SAVE_LENGTH,SAVE_START,SAVE_LENGTH >> temp.z80
echo #endif>>temp.z80
type %1.name >> temp.z80
echo.>>temp.z80
echo .end >> temp.z80
%ASM83DIR%tasm -80 -i -b -l temp.z80 temp.bin

copy /b temp.bin + %1.pu %1.bin

copy %1.8xp %1_prior_file.8xp

%ASM83DIR%devpac8x %1
copy %1.8xp %1c.8xp
copy %1_prior_file.8xp %1.8xp
del %1_prior_file.8xp > nul

echo ----- Success!
echo TI-83 Plus Crunchy version is %1c.8xp
goto DONE
:ERRORS
echo ----- There were errors.
:DONE
rem del temp.z80 > nul
rem del %1.bin > nul

call %ASM83DIR%_cleanall.bat
cd %ASM83DIR%
set ASM83DIR=

goto Done2
:usage
echo Usage:
echo -----------------------------------------------------------------------------
echo   %0 progname [progpath]
echo.
echo   Progname is the base filename of the program, leave off the file extension.
echo   Progpath is a path to the program, so you can compile a project located in
echo   in a different folder.  Run this .bat file from the TASM folder.
echo.
echo   You also need a file called "progname.name" to exist, and labels SAVE_START
echo   and SAVE_LENGTH must be defined in the program.
echo.
echo   This .bat builds TI83+ CrunchyOS programs.
echo.
:Done2
